﻿using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Windows.Forms;

using System.Security.Cryptography;

namespace Encrypted_Mutlicasting_Chat_System
{
   public class CryptographyClass
   {
       #region RSA Encryption
       public byte[] RSAEncryption(string XMLKey, string MSG)
       {
           try
           {
               //  Performs asymmetric encryption using 
               //  the implementation of the RSA algorithm
               //  provided by the cryptographic service provider (CSP). 
               RSACryptoServiceProvider rsa = new RSACryptoServiceProvider();
               rsa.FromXmlString(XMLKey); // Read The Server Key

               // Represent the message to be as a byte array 
               // using the unicode encoding
               byte[] PlainBuufer = Encoding.Unicode.GetBytes(MSG);

               // Encrypt The Plain Buffer  
               return rsa.Encrypt(PlainBuufer, true);
           }
           catch (Exception) { return null; }
       }

       public string RSADecryption(byte[] EncryptedBuffer, string XMLKey)
       {
           try
           {
               //  Performs asymmetric decryption using
               //  the implementation of the RSA algorithm
               //  provided by the cryptographic service provider (CSP). 
               RSACryptoServiceProvider rsa = new RSACryptoServiceProvider();
               rsa.FromXmlString(XMLKey); // Read The Server Key

               // Decrypt The Encrypted Buffer
               byte[] data = rsa.Decrypt(EncryptedBuffer, true);

               // Return The Decrypted Message After Decoding
               return UnicodeEncoding.Unicode.GetString(data);
           }
           catch (Exception) { return string.Empty; }
       }
       #endregion RSA Encryption
   }
    
}
