﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.Services;
using System.Security.Cryptography;
using System.Security;
using System.Text;

namespace Key_Management_Server
{
    /// <summary>
    /// Summary description for Service1
    /// </summary>
    [WebService(Namespace = "http://tempuri.org/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    [System.ComponentModel.ToolboxItem(false)]
    public class Service1 : System.Web.Services.WebService
    {
        #region Key Management

        // (CspParameters) Contains parameters that are passed 
        // to the cryptographic service provider (CSP)
        // to generate the public key
            CspParameters ServerKey;

        // (RSACryptoServiceProvider) Performs asymmetric encryption
        //  and decryption using the implementation of the RSA algorithm
        //  provided by the cryptographic service provider (CSP). 
            RSACryptoServiceProvider csp;

        [WebMethod]
        public string GetTheServerKey(string RoomID)
        {
            // Generate The Public Key By Using The RoomID 
            // And The Server MachineKey  
            ServerKey = new CspParameters();
            ServerKey.KeyContainerName = RoomID;
            ServerKey.Flags = CspProviderFlags.UseMachineKeyStore;
            ServerKey.KeyNumber = 1; // Type1: Exchange Key

            // Generate The Private Key and 
            // Return The Private and The Public Keys as XML Data 
            csp = new RSACryptoServiceProvider(ServerKey); 
            return csp.ToXmlString(true); 
        }
        #endregion Key Management
    }



}
